doctype html
html(lang="en")
  head
    meta(charset="UTF-8")
    meta(http-equiv="X-UA-Compatible", content="IE=edge")
    meta(name="viewport", content="width=device-width, initial-scale=1.0")

    title Checkout

    link(href="https://unpkg.com/tailwindcss@^2/dist/tailwind.min.css" rel="stylesheet")

    script(src="https://cdn.jsdelivr.net/gh/alpinejs/alpine@v2.7.0/dist/alpine.min.js" defer)
    script(
      src="https://cdnjs.cloudflare.com/ajax/libs/cleave.js/1.6.0/cleave.min.js"
      integrity="sha512-KaIyHb30iXTXfGyI9cyKFUIRSSuekJt6/vqXtyQKhQP6ozZEGY8nOtRS6fExqE4+RbYHus2yGyYg1BrqxzV6YA=="
      crossorigin="anonymous"
      referrerpolicy="no-referrer")
    script(src="./assets/js/faker.min.js")

    //- SrPago dependency libraries
    script(src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js")
    script(type="text/javascript" src="https://js.srpago.com/v1/srpago.min.js")
    script(type="text/javascript" src="https://js.srpago.com/v1/srpago.encryption.min.js")

    style(media="screen").
      .disabled\:opacity-50:disabled {
        cursor: wait;
        opacity: .5;
      }
  body
    div(x-data="frmCheckout()" x-init="init()")
      div(class="bg-gray-300 text-gray-500 min-h-screen" x-cloak)
        div(class="py-6")
          div(class="max-w-md mx-auto bg-white shadow-lg rounded-lg md:max-w-xl mx-2")
            div(class="md:flex")
              div(class="w-full p-4 px-5 py-5")
                div(class="flex justify-center text-green-400")
                  h2(class="text-3xl font-semibold uppercase")
                    span(x-show="step('checkout')" x-transition) Checkout
                    span(x-show="step('completed')" x-transition) Completed

                //- Step: Checkout
                div(x-show="step('checkout')" x-transition)

                  //- Order Information
                  div(class="mt-6")
                    p(class="text-lg font-semibold uppercase text-green-400") Order information

                    div(class="mt-2")
                      label(for="checkout_description" class="block text-sm font-semibold") Description
                      input(
                        type="text"
                        id="checkout_description"
                        x-model="data.checkout.description"
                        class="border rounded h-10 w-full focus:outline-none focus:border-green-200 px-2 text-sm"
                      )

                    div(class="grid md:grid-cols-3 md:gap-2")
                      div(class="mt-2")
                        label(for="checkout_reference" class="block text-sm font-semibold") Reference
                        input(
                          type="text"
                          id="checkout_reference"
                          x-model="data.checkout.reference"
                          class="border rounded h-10 w-full focus:outline-none focus:border-green-200 px-2 text-sm"
                        )

                      div(class="mt-2")
                        label(for="checkout_amount" class="block text-sm font-semibold") Amount
                        input(
                          type="text"
                          id="checkout_amount"
                          x-model="data.checkout.amount"
                          class="border rounded h-10 w-full focus:outline-none focus:border-green-200 px-2 text-sm"
                        )

                      div(class="mt-2")
                        label(for="checkout_currency" class="block text-sm font-semibold") Currency
                        select(
                          id="checkout_currency"
                          x-model="data.checkout.currency"
                          class="border rounded h-10 w-full focus:outline-none focus:border-green-200 px-2 text-sm bg-white"
                        )
                          template(x-for="currency in catalogs.currencies" :key="currency")
                            option(:value="currency" x-text="currency")

                  //- Customer Information
                  div(class="mt-6")
                    p(class="text-lg font-semibold uppercase text-green-400") Customer information

                    div(class="mt-2")
                      label(for="checkout_customer_name" class="block text-sm font-semibold") Name
                      input(
                        type="text"
                        id="checkout_customer_name"
                        x-model="data.checkout.customer.name"
                        class="border rounded h-10 w-full focus:outline-none focus:border-green-200 px-2 text-sm"
                      )

                    div(class="mt-2")
                      label(for="checkout_customer_email" class="block text-sm font-semibold") Email
                      div(class="relative")
                        input(
                          type="email"
                          id="checkout_customer_email"
                          x-model="data.checkout.customer.email"
                          class="border rounded h-10 w-full focus:outline-none focus:border-green-200 px-2 text-sm"
                        )

                  //- Card Information
                  div(class="mt-6")
                    p(class="text-lg font-semibold uppercase text-green-400") Card information

                    div(class="mt-2")
                      label(for="card_owner" class="block text-sm font-semibold") Owner
                      input(
                        type="text"
                        id="card_owner"
                        x-model="data.card.owner"
                        class="border rounded h-10 w-full focus:outline-none focus:border-green-200 px-2 text-sm"
                      )

                    div(class="mt-2")
                      label(for="card_number" class="block text-sm font-semibold") Number
                      div(class="relative")
                        input(
                          type="text"
                          id="card_number"
                          x-model="data.card.number"
                          class="input-card-number border rounded h-10 w-full focus:outline-none focus:border-green-200 px-2 text-sm"
                          placeholder="0000 0000 0000 0000"
                        )

                    div(class="grid md:grid-cols-2 md:gap-2")
                      div(class="mt-2")
                        label(for="card_expiry" class="block text-sm font-semibold") Expiry
                        input(
                          type="text"
                          id="card_expiry"
                          class="input-card-expiry border rounded h-10 w-full focus:outline-none focus:border-green-200 px-2 text-sm"
                          placeholder="MM/YY"
                          :value="`${data.card.expiry_month}/${data.card.expiry_year}`"
                        )

                      div(class="mt-2")
                        label(for="card_cvv" class="block text-sm font-semibold") CVV
                        input(
                          type="password"
                          id="card_cvv"
                          x-model="data.card.cvv"
                          class="border rounded h-10 w-full focus:outline-none focus:border-green-200 px-2 text-sm"
                          placeholder="***"
                          maxlength="4"
                        )

                  //- Error Messages
                  div(
                    x-show="data.error.message"
                    class="mt-6 py-3 pl-4 pr-10 leading-normal text-red-800 bg-red-50 border-t-4 border-red-400"
                  )
                    div(class="font-bold" x-text="data.error.message")

                  div(class="flex justify-end mt-6")
                    button(
                      type="button"
                      class="disabled:opacity-50 h-10 w-48 rounded font-bold text-xl bg-blue-500 hover:bg-blue-400 text-white tracking-widest"
                      x-bind:disabled="data.working"
                      @click="handleSubmit()"
                    )
                      span(x-show="!data.working") PAY |
                        span(x-text="` $${data.checkout.amount}`")
                      span(x-show="data.working" class="text-base") PROCESSING ...

                //- Step: Completed
                div(x-show="step('completed')" x-transition)

                  div(class="mt-2 text-center")
                    p The payment has been completed
                    p(class="text-gray-400 text-center text-xs font-semibold")
                      a(x-bind:href="data.receipt_url" target="_blank" class="font-normal") Receipt of payment

                  img(
                    src="https://image.flaticon.com/icons/png/512/190/190411.png"
                    class="w-24 h-24 mx-auto my-8"
                  )

          div(class="w-full mt-1 text-center text-xs text-gray-400")
            span(class="pr-2") Powered by #[strong SrPago]
            span -
            span(class="pl-2" x-text="`v${version}`")

    script.
      const C = {
        ENDPOINT_CHECKOUT_PAYMENT: `#{app_host}/api/checkout/payment`,

        SRPAGO_LIVEMODE: #{srpago_livemode},
        SRPAGO_APIKEY: '#{srpago_apikey}',
      };

      SrPago.setLiveMode(C.SRPAGO_LIVEMODE);
      SrPago.setPublishableKey(C.SRPAGO_APIKEY);

      function frmCheckout() {
        return {
          version: '0.1.0',

          data: {
            // This structure is sent to the server to make the payment request.
            checkout: {
              reference: null,
              description: null,
              amount: 0,
              currency: 'MXN',

              customer: {
                name: null,
                email: null,
              },

              card: {
                token: null,
              },
            },

            // This structure is used to tokenize the card.
            // For security reasons, this information should never be sent to the merchant server.
            card: {
              owner: null,
              number: null,
              expiry_month: null,
              expiry_year: null,
              cvv: null,
            },

            receipt_url: '',

            step: 'checkout', // checkout | completed
            working: false,

            error: {
              message: '',
            },
          },

          catalogs: {
            currencies: [
              'MXN',
            ],
          },

          async init() {
            const randomInt = function (min, max) {
              return Math.floor(Math.random() * (max - min)) + min;
            };

            const customerFirstname = faker.name.firstName();
            const customerLastname = faker.name.lastName();
            const date = new Date();

            this.data.checkout.reference = `ref_${faker.git.shortSha()}`;
            this.data.checkout.description = faker.commerce.productName();
            this.data.checkout.amount = faker.finance.amount();
            this.data.checkout.customer.name = `${customerFirstname} ${customerLastname}`;
            this.data.checkout.customer.email = faker.internet.exampleEmail(customerFirstname, customerLastname).toLowerCase();
            this.data.card.owner = faker.fake("{{name.firstName}} {{name.lastName}}");
            this.data.card.number = faker.helpers.replaceCreditCardSymbols('5204 #### #### ###L', '#');
            this.data.card.expiry_month = ('0' + date.getMonth()).slice(-2);
            this.data.card.expiry_year = date.getFullYear() + randomInt(2, 10);
            this.data.card.cvv = faker.finance.creditCardCVV();


            new Cleave('.input-card-number', {
              creditCard: true,
            });

            new Cleave('.input-card-expiry', {
              date: true,
              datePattern: ['m', 'y'],
              onValueChanged: e => {
                const expiry = e.target.value.split('/');

                this.data.expiry_month = expiry[0] || '';
                this.data.expiry_year = expiry[1] || '';
              }
            });
          },

          step(step) {
            return step == this.data.step;
          },

          toStep(step) {
            return this.data.step = step;
          },

          async handleSubmit() {
            this.data.working = true;
            this.data.error.message = '';

            // Callback that is executed if tokenization was successful.
            const successResponseHandler = response => {
              this.data.checkout.card.token = response.token;

              // Payment request is sent.
              fetch(`${C.ENDPOINT_CHECKOUT_PAYMENT}`, {
                headers: {
                  'Content-Type': 'application/json',
                },
                redirect: 'follow',
                method: 'POST',
                body: JSON.stringify(this.data.checkout),
              })
                .then(response => response.json())
                .then(response => {
                  this.data.receipt_url = response.recipe.url;

                  this.toStep('completed');
                })
                .catch(error => {
                  this.data.error.message = `ERROR: ${error.message}`;
                })
                .finally(() => { this.data.working = false; });
            };

            // Callback that is executed if a tokenization error has occurred.
            const errorResponseHandler = error => {
              this.data.error.message = `ERROR: (${error.code}) ${error.message}`;

              this.data.working = false;
            };

            const tokenizationPayload = {
              number: this.data.card.number.replace(/\s/g, ''),
              holder_name: ReplaceAccents(this.data.card.owner),
              cvv: this.data.card.cvv,
              exp_month: this.data.card.expiry_month,
              exp_year: this.data.card.expiry_year,
            };

            SrPago.token.create(tokenizationPayload, successResponseHandler, errorResponseHandler);
          },
        }
      };

      function ReplaceAccents(text) {
        const accentsMap = {
          a: 'á|à|ã|â|À|Á|Ã|Â',
          e: 'é|è|ê|É|È|Ê',
          i: 'í|ì|î|Í|Ì|Î',
          o: 'ó|ò|ô|õ|Ó|Ò|Ô|Õ',
          u: 'ú|ù|û|ü|Ú|Ù|Û|Ü',
          c: 'ç|Ç',
          n: 'ñ|Ñ',
        };

        return Object.keys(accentsMap).reduce(
          (acc, cur) => acc.replace(new RegExp(accentsMap[cur], 'g'), cur),
          text
        );
      }
